;===============================================================================
;
; Description:      Syntax highlighting files installation for EditPlus 3
; Requirement(s):   Autoit 3.x
; Author(s):        Dmitry Yudin (Lazycat)
; Version:          3.0
; Date:             16.07.2008
;
;===============================================================================

If MsgBox(262180, "Autoit 3.x syntax installation for EditPlus 3",_
   "This script will attempt to automatically install or update syntax highlighting," & @CR &_
   "clip and autocomplete library files for EditPlus 3. Run?") = 7 Then Exit

Dim $sPath, $sExt, $iCnt = 0

$sPath = RegRead("HKEY_CURRENT_USER\Software\ES-Computing\EditPlus 3\Install", "INI directory")
If @error or (not FileExists($sPath & "\editplus.exe")) Then
    While 1
        $sPath = FileSelectFolder ("Please select a folder where EditPlus 3 is installed:", "::{20D04FE0-3AEA-1069-A2D8-08002B30309D}", 0)
        If @error then exit
        If FileExists($sPath & "\editplus.exe") Then 
            RegWrite("HKEY_CURRENT_USER\Software\ES-Computing\EditPlus 3\Install", "INI directory", "REG_SZ", $sPath)
            ExitLoop
        Endif
        MsgBox (262192, "Problem detected", "The file editplus.exe not found. Try to select folder again.")
    Wend
Endif

If not FileCopy(@ScriptDir & "\autoit3.stx", $sPath & "\autoit3.stx", 1) Then Error()
If not FileCopy(@ScriptDir & "\autoit3.ctl", $sPath & "\autoit3.ctl", 1) Then Error()
If not FileCopy(@ScriptDir & "\autoit3.acp", $sPath & "\autoit3.acp", 1) Then Error()
$sFileName = $sPath & "\setting.ini"

While 1
    $iCnt = $iCnt + 1
    $sSection = "Settings\Custom" & String($iCnt)
    $sExt = IniRead($sFileName, $sSection, "Extension", "error")
    If $sExt == "error" Then 
        IniWrite($sFileName, $sSection, "Extension", "au3")
        IniWrite($sFileName, $sSection, "File", $sPath & "\Autoit3.acp")
        IniWrite($sFileName, $sSection, "Syntax file", $sPath & "\Autoit3.stx")
        IniWrite($sFileName, $sSection, "Description", "Autoit3 Script File")
        IniWrite($sFileName, $sSection, "Auto Indent", "1")
        IniWrite($sFileName, $sSection, "Tab", "4")
        IniWrite($sFileName, $sSection, "Indent", "4")
        IniWrite($sFileName, $sSection, "Insert Space", "1")
        IniWrite($sFileName, $sSection, "0", "16711680")
        IniWrite($sFileName, $sSection, "1", "255")
        IniWrite($sFileName, $sSection, "2", "8421376")
        IniWrite($sFileName, $sSection, "3", "32896")
        IniWrite($sFileName, $sSection, "4", "16739678")
        IniWrite($sFileName, $sSection, "6", "8421504")
        IniWrite($sFileName, $sSection, "9", "16711935")
        IniWrite($sFileName, $sSection, "10", "16711935")
        IniWrite($sFileName, $sSection, "16", "16711935")
        IniWrite($sFileName, $sSection, "Function", "^[ \t]*func[ \t].*\([^;]*$")
        Exitloop
    Endif
    If $sExt == "au3" Then Exitloop
Wend 


MsgBox (262208, "Information", "Autoit3 syntax for EditPlus 3 is successfully installed.")

Func Error()
	MsgBox(262160, "Error", "Unable to copy the syntax files. Please try a manual installation.")
	Exit
EndFunc
